## ros-one-imu-complementary-filter 1.2.6-4jammy.20251023.0848

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5.1)
project(imu_complementary_filter)

find_package(Boost REQUIRED COMPONENTS thread)

find_package(catkin REQUIRED COMPONENTS
  cmake_modules
  geometry_msgs
  message_filters
  nodelet
  pluginlib
  roscpp
  sensor_msgs
  std_msgs
  tf
)

catkin_package(
  INCLUDE_DIRS include
  LIBRARIES complementary_filter
  CATKIN_DEPENDS
    geometry_msgs
    message_filters
    nodelet
    pluginlib
    roscpp
    sensor_msgs
    std_msgs
    tf
)

include_directories(
  include
  ${catkin_INCLUDE_DIRS}
  ${Boost_INCLUDE_DIRS}
)

## Declare a cpp library
add_library(complementary_filter
  include/imu_complementary_filter/complementary_filter.h
  include/imu_complementary_filter/complementary_filter_ros.h
  src/complementary_filter.cpp
  src/complementary_filter_ros.cpp
)
target_link_libraries(complementary_filter ${catkin_LIBRARIES} ${Boost_LIBRARIES})

# create complementary_filter_nodelet library
add_library (complementary_filter_nodelet src/complementary_filter_nodelet.cpp)
target_link_libraries(complementary_filter_nodelet complementary_filter ${catkin_LIBRARIES})

# create complementary_filter_node executable
add_executable(complementary_filter_node
  src/complementary_filter_node.cpp)
target_link_libraries(complementary_filter_node complementary_filter ${catkin_LIBRARIES})

install(TARGETS complementary_filter complementary_filter_nodelet
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_GLOBAL_BIN_DESTINATION}
)

install(TARGETS complementary_filter_node
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

## Mark cpp header files for installation
install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
  FILES_MATCHING PATTERN "*.h"
  PATTERN ".svn" EXCLUDE
)

install(FILES complementary_filter_nodelet.xml
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)

=== debian/changelog ===
ros-one-imu-complementary-filter (1.2.6-4jammy.20251023.0848) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Roberto G. Valenti <robertogl.valenti@gmail.com>  Thu, 23 Oct 2025 08:48:59 +0000

ros-one-imu-complementary-filter (1.2.6-0jammy) jammy; urgency=high

  * complementary filter launch: Remove outdated phidgets_imu nodelet
    The phidgets_imu package was renamed to phidgets_spatial. To avoid
    adding a dependency on phidgets_spatial, this commit removes the include
    of that nodelet altogether.
    If launching the phidgets driver is desired, it should be done like in
    this launch file:
    https://github.com/ros-drivers/phidgets_drivers/blob/20512def27a74666aeb2eb2d31ff2faf45062c35/phidgets_spatial/launch/spatial.launch
    Fixes #186 <https://github.com/CCNYRoboticsLab/imu_tools/issues/186>.
  * add complementary_filter_nodelet (#181 <https://github.com/CCNYRoboticsLab/imu_tools/issues/181>)
  * Contributors: Borong Yuan, Martin Günther

 -- Roberto G. Valenti <robertogl.valenti@gmail.com>  Fri, 12 Jan 2024 00:00:00 -0000

ros-one-imu-complementary-filter (1.2.5-0jammy) jammy; urgency=high

  * Added ability to reset IMU filters when ROS time jumps back. (#165 <https://github.com/CCNYRoboticsLab/imu_tools/issues/165>)
  * Contributors: Martin Pecka

 -- Roberto G. Valenti <robertogl.valenti@gmail.com>  Fri, 19 Aug 2022 00:00:00 -0000

ros-one-imu-complementary-filter (1.2.4-0jammy) jammy; urgency=high

  * Manually reformat licenses + defines
  * Reformat everything using clang-format
  * Fix package dependencies
  * Fix trailing whitespace
  * Contributors: Martin Günther

 -- Roberto G. Valenti <robertogl.valenti@gmail.com>  Tue, 12 Apr 2022 00:00:00 -0000

ros-one-imu-complementary-filter (1.2.3-0jammy) jammy; urgency=high

  * Fix "non standard content" warning in imu_tools metapackage
    Fixes #135 <https://github.com/ccny-ros-pkg/imu_tools/issues/135>.
  * Set cmake_policy CMP0048 to fix warning
  * Contributors: Martin Günther

 -- Roberto G. Valenti <robertogl.valenti@gmail.com>  Fri, 09 Apr 2021 00:00:00 -0000

ros-one-imu-complementary-filter (1.2.2-0jammy) jammy; urgency=high

  * fix install path & boost linkage issues
  * Contributors: Martin Günther, Sean Yen

 -- Roberto G. Valenti <robertogl.valenti@gmail.com>  Mon, 25 May 2020 00:00:00 -0000

ros-one-imu-complementary-filter (1.2.1-0jammy) jammy; urgency=high

  * Remove junk xml (#93 <https://github.com/ccny-ros-pkg/imu_tools/issues/93>)
  * Fix C++14 builds (#89 <https://github.com/ccny-ros-pkg/imu_tools/issues/89>)
  * Contributors: David V. Lu!!, Paul Bovbel

 -- Roberto G. Valenti <robertogl.valenti@gmail.com>  Mon, 06 May 2019 00:00:00 -0000

ros-one-imu-complementary-filter (1.2.0-0jammy) jammy; urgency=high

  * Add std dev parameter to orientation estimate from filter (#85 <https://github.com/ccny-ros-pkg/imu_tools/issues/85>)
    Similar to #41 <https://github.com/ccny-ros-pkg/imu_tools/issues/41>, but not using dynamic_reconfigure as not implemented for complementary filter
  * Contributors: Stefan Kohlbrecher

 -- Roberto G. Valenti <robertogl.valenti@gmail.com>  Fri, 25 May 2018 00:00:00 -0000

ros-one-imu-complementary-filter (1.1.5-0jammy) jammy; urgency=high



 -- Roberto G. Valenti <robertogl.valenti@gmail.com>  Wed, 24 May 2017 00:00:00 -0000

ros-one-imu-complementary-filter (1.1.4-0jammy) jammy; urgency=high



 -- Roberto G. Valenti <robertogl.valenti@gmail.com>  Mon, 22 May 2017 00:00:00 -0000

ros-one-imu-complementary-filter (1.1.3-0jammy) jammy; urgency=high

  * complementary_filter: move const initializations out of header
    Initialization of static consts other than int (here: float) inside the
    class declaration is not permitted in C++. It works in gcc (due to a
    non-standard extension), but throws an error in C++11.
  * Contributors: Martin Guenther

 -- Roberto G. Valenti <robertogl.valenti@gmail.com>  Fri, 10 Mar 2017 00:00:00 -0000

ros-one-imu-complementary-filter (1.1.2-0jammy) jammy; urgency=high



 -- Roberto G. Valenti <robertogl.valenti@gmail.com>  Wed, 07 Sep 2016 00:00:00 -0000

ros-one-imu-complementary-filter (1.1.1-0jammy) jammy; urgency=high



 -- Roberto G. Valenti <robertogl.valenti@gmail.com>  Wed, 07 Sep 2016 00:00:00 -0000

ros-one-imu-complementary-filter (1.1.0-0jammy) jammy; urgency=high



 -- Roberto G. Valenti <robertogl.valenti@gmail.com>  Mon, 25 Apr 2016 00:00:00 -0000

ros-one-imu-complementary-filter (1.0.11-0jammy) jammy; urgency=high



 -- Roberto G. Valenti <robertogl.valenti@gmail.com>  Fri, 22 Apr 2016 00:00:00 -0000

ros-one-imu-complementary-filter (1.0.10-0jammy) jammy; urgency=high

  * Remove Eigen dependency
    Eigen is not actually used anywhere. Thanks @asimay!
  * Removed main function from shared library
  * Contributors: Martin Guenther, Matthias Nieuwenhuisen

 -- Roberto G. Valenti <robertogl.valenti@gmail.com>  Fri, 22 Apr 2016 00:00:00 -0000

ros-one-imu-complementary-filter (1.0.9-0jammy) jammy; urgency=high

  * complementary: Add Eigen dependency
    Fixes #54 <https://github.com/ccny-ros-pkg/imu_tools/issues/54>.
  * Contributors: Martin Günther

 -- Roberto G. Valenti <robertogl.valenti@gmail.com>  Fri, 16 Oct 2015 00:00:00 -0000

ros-one-imu-complementary-filter (1.0.8-0jammy) jammy; urgency=high



 -- Roberto G. Valenti <robertogl.valenti@gmail.com>  Wed, 07 Oct 2015 00:00:00 -0000

ros-one-imu-complementary-filter (1.0.7-0jammy) jammy; urgency=high

  * Allow remapping imu namespace
  * Publish RPY as Vector3Stamped
  * Add params: constant_dt, publish_tf, reverse_tf, publish_debug_topics
  * Use MagneticField instead of Vector3
  * Contributors: Martin Günther

 -- Roberto G. Valenti <robertogl.valenti@gmail.com>  Wed, 07 Oct 2015 00:00:00 -0000

ros-one-imu-complementary-filter (1.0.6-0jammy) jammy; urgency=high

  * Add new package: imu_complementary_filter
  * Contributors: Roberto G. Valentini, Martin Günther, Michael Görner



=== debian/control ===
Source: ros-one-imu-complementary-filter
Section: misc
Priority: optional
Maintainer: Roberto G. Valenti <robertogl.valenti@gmail.com>
Build-Depends: debhelper (>= 9.0.0), ros-one-catkin, ros-one-cmake-modules, ros-one-geometry-msgs, ros-one-message-filters, ros-one-nodelet, ros-one-pluginlib, ros-one-roscpp, ros-one-sensor-msgs, ros-one-std-msgs, ros-one-tf
Homepage: http://www.mdpi.com/1424-8220/15/8/19302
Standards-Version: 3.9.2

Package: ros-one-imu-complementary-filter
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-one-geometry-msgs, ros-one-message-filters, ros-one-nodelet, ros-one-pluginlib, ros-one-roscpp, ros-one-sensor-msgs, ros-one-std-msgs, ros-one-tf
Description: Filter which fuses angular velocities, accelerations, and (optionally) magnetic readings from a generic IMU device into a quaternion to represent the orientation of the device wrt the global frame.
 Based on the algorithm by Roberto G. Valenti etal. described in the paper &quot;Keeping a Good Attitude: A Quaternion-Based Orientation Filter for IMUs and MARGs&quot; available at http://www.mdpi.com/1424-8220/15/8/19302 .

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/one/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF -DCATKIN_ENABLE_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_configure -- \
		-DFETCHCONTENT_FULLY_DISCONNECTED=OFF \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/one" \
		-DCMAKE_PREFIX_PATH="/opt/ros/one" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-one-imu-complementary-filter//opt/ros/one/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_install

## ros-one-imu-complementary-filter 1.2.6-4jammy.20251207.2143

=== debian/changelog ===
ros-one-imu-complementary-filter (1.2.6-4jammy.20251207.2143) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Roberto G. Valenti <robertogl.valenti@gmail.com>  Sun, 07 Dec 2025 21:43:14 +0000

## ros-one-imu-complementary-filter 1.2.6-4noble.20251023.0856

=== debian/changelog ===
ros-one-imu-complementary-filter (1.2.6-4noble.20251023.0856) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Roberto G. Valenti <robertogl.valenti@gmail.com>  Thu, 23 Oct 2025 08:56:31 +0000

ros-one-imu-complementary-filter (1.2.6-0noble) noble; urgency=high

  * complementary filter launch: Remove outdated phidgets_imu nodelet
    The phidgets_imu package was renamed to phidgets_spatial. To avoid
    adding a dependency on phidgets_spatial, this commit removes the include
    of that nodelet altogether.
    If launching the phidgets driver is desired, it should be done like in
    this launch file:
    https://github.com/ros-drivers/phidgets_drivers/blob/20512def27a74666aeb2eb2d31ff2faf45062c35/phidgets_spatial/launch/spatial.launch
    Fixes #186 <https://github.com/CCNYRoboticsLab/imu_tools/issues/186>.
  * add complementary_filter_nodelet (#181 <https://github.com/CCNYRoboticsLab/imu_tools/issues/181>)
  * Contributors: Borong Yuan, Martin Günther

 -- Roberto G. Valenti <robertogl.valenti@gmail.com>  Fri, 12 Jan 2024 00:00:00 -0000

ros-one-imu-complementary-filter (1.2.5-0noble) noble; urgency=high

  * Added ability to reset IMU filters when ROS time jumps back. (#165 <https://github.com/CCNYRoboticsLab/imu_tools/issues/165>)
  * Contributors: Martin Pecka

 -- Roberto G. Valenti <robertogl.valenti@gmail.com>  Fri, 19 Aug 2022 00:00:00 -0000

ros-one-imu-complementary-filter (1.2.4-0noble) noble; urgency=high

  * Manually reformat licenses + defines
  * Reformat everything using clang-format
  * Fix package dependencies
  * Fix trailing whitespace
  * Contributors: Martin Günther

 -- Roberto G. Valenti <robertogl.valenti@gmail.com>  Tue, 12 Apr 2022 00:00:00 -0000

ros-one-imu-complementary-filter (1.2.3-0noble) noble; urgency=high

  * Fix "non standard content" warning in imu_tools metapackage
    Fixes #135 <https://github.com/ccny-ros-pkg/imu_tools/issues/135>.
  * Set cmake_policy CMP0048 to fix warning
  * Contributors: Martin Günther

 -- Roberto G. Valenti <robertogl.valenti@gmail.com>  Fri, 09 Apr 2021 00:00:00 -0000

ros-one-imu-complementary-filter (1.2.2-0noble) noble; urgency=high

  * fix install path & boost linkage issues
  * Contributors: Martin Günther, Sean Yen

 -- Roberto G. Valenti <robertogl.valenti@gmail.com>  Mon, 25 May 2020 00:00:00 -0000

ros-one-imu-complementary-filter (1.2.1-0noble) noble; urgency=high

  * Remove junk xml (#93 <https://github.com/ccny-ros-pkg/imu_tools/issues/93>)
  * Fix C++14 builds (#89 <https://github.com/ccny-ros-pkg/imu_tools/issues/89>)
  * Contributors: David V. Lu!!, Paul Bovbel

 -- Roberto G. Valenti <robertogl.valenti@gmail.com>  Mon, 06 May 2019 00:00:00 -0000

ros-one-imu-complementary-filter (1.2.0-0noble) noble; urgency=high

  * Add std dev parameter to orientation estimate from filter (#85 <https://github.com/ccny-ros-pkg/imu_tools/issues/85>)
    Similar to #41 <https://github.com/ccny-ros-pkg/imu_tools/issues/41>, but not using dynamic_reconfigure as not implemented for complementary filter
  * Contributors: Stefan Kohlbrecher

 -- Roberto G. Valenti <robertogl.valenti@gmail.com>  Fri, 25 May 2018 00:00:00 -0000

ros-one-imu-complementary-filter (1.1.5-0noble) noble; urgency=high



 -- Roberto G. Valenti <robertogl.valenti@gmail.com>  Wed, 24 May 2017 00:00:00 -0000

ros-one-imu-complementary-filter (1.1.4-0noble) noble; urgency=high



 -- Roberto G. Valenti <robertogl.valenti@gmail.com>  Mon, 22 May 2017 00:00:00 -0000

ros-one-imu-complementary-filter (1.1.3-0noble) noble; urgency=high

  * complementary_filter: move const initializations out of header
    Initialization of static consts other than int (here: float) inside the
    class declaration is not permitted in C++. It works in gcc (due to a
    non-standard extension), but throws an error in C++11.
  * Contributors: Martin Guenther

 -- Roberto G. Valenti <robertogl.valenti@gmail.com>  Fri, 10 Mar 2017 00:00:00 -0000

ros-one-imu-complementary-filter (1.1.2-0noble) noble; urgency=high



 -- Roberto G. Valenti <robertogl.valenti@gmail.com>  Wed, 07 Sep 2016 00:00:00 -0000

ros-one-imu-complementary-filter (1.1.1-0noble) noble; urgency=high



 -- Roberto G. Valenti <robertogl.valenti@gmail.com>  Wed, 07 Sep 2016 00:00:00 -0000

ros-one-imu-complementary-filter (1.1.0-0noble) noble; urgency=high



 -- Roberto G. Valenti <robertogl.valenti@gmail.com>  Mon, 25 Apr 2016 00:00:00 -0000

ros-one-imu-complementary-filter (1.0.11-0noble) noble; urgency=high



 -- Roberto G. Valenti <robertogl.valenti@gmail.com>  Fri, 22 Apr 2016 00:00:00 -0000

ros-one-imu-complementary-filter (1.0.10-0noble) noble; urgency=high

  * Remove Eigen dependency
    Eigen is not actually used anywhere. Thanks @asimay!
  * Removed main function from shared library
  * Contributors: Martin Guenther, Matthias Nieuwenhuisen

 -- Roberto G. Valenti <robertogl.valenti@gmail.com>  Fri, 22 Apr 2016 00:00:00 -0000

ros-one-imu-complementary-filter (1.0.9-0noble) noble; urgency=high

  * complementary: Add Eigen dependency
    Fixes #54 <https://github.com/ccny-ros-pkg/imu_tools/issues/54>.
  * Contributors: Martin Günther

 -- Roberto G. Valenti <robertogl.valenti@gmail.com>  Fri, 16 Oct 2015 00:00:00 -0000

ros-one-imu-complementary-filter (1.0.8-0noble) noble; urgency=high



 -- Roberto G. Valenti <robertogl.valenti@gmail.com>  Wed, 07 Oct 2015 00:00:00 -0000

ros-one-imu-complementary-filter (1.0.7-0noble) noble; urgency=high

  * Allow remapping imu namespace
  * Publish RPY as Vector3Stamped
  * Add params: constant_dt, publish_tf, reverse_tf, publish_debug_topics
  * Use MagneticField instead of Vector3
  * Contributors: Martin Günther

 -- Roberto G. Valenti <robertogl.valenti@gmail.com>  Wed, 07 Oct 2015 00:00:00 -0000

ros-one-imu-complementary-filter (1.0.6-0noble) noble; urgency=high

  * Add new package: imu_complementary_filter
  * Contributors: Roberto G. Valentini, Martin Günther, Michael Görner



## ros-one-imu-complementary-filter 1.2.6-4noble.20251208.0842

=== debian/changelog ===
ros-one-imu-complementary-filter (1.2.6-4noble.20251208.0842) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Roberto G. Valenti <robertogl.valenti@gmail.com>  Mon, 08 Dec 2025 08:42:59 +0000

## ros-one-imu-complementary-filter 1.2.7-2jammy.20260223.2133

=== debian/changelog ===
ros-one-imu-complementary-filter (1.2.7-2jammy.20260223.2133) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Roberto G. Valenti <robertogl.valenti@gmail.com>  Mon, 23 Feb 2026 21:33:47 +0000

ros-one-imu-complementary-filter (1.2.7-0jammy) jammy; urgency=high



 -- Roberto G. Valenti <robertogl.valenti@gmail.com>  Tue, 29 Apr 2025 00:00:00 -0000

## ros-one-imu-complementary-filter 1.2.7-2noble.20260223.2127

=== debian/changelog ===
ros-one-imu-complementary-filter (1.2.7-2noble.20260223.2127) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Roberto G. Valenti <robertogl.valenti@gmail.com>  Mon, 23 Feb 2026 21:27:50 +0000

ros-one-imu-complementary-filter (1.2.7-0noble) noble; urgency=high



 -- Roberto G. Valenti <robertogl.valenti@gmail.com>  Tue, 29 Apr 2025 00:00:00 -0000
